#ifndef __SYNTHFRAME_H__
#define __SYNTHFRAME_H__

#include <wx/wxprec.h>
 
#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

class SynthFrame : public wxFrame {
public:
    SynthFrame();
 
private:
    enum {
        UNISON_SLIDER = wxID_TOP,

        OSC1_MODE_SLIDER,
        OSC2_MODE_SLIDER,

        OSC_DET_SLIDER,
        OSC2_PIT_SLIDER,
        OSC_MIX_SLIDER,

        NOISE_MIX_SLIDER,

        FLT_TYPE_SLIDER,
        FLT_SLOPE_SLIDER,
        FLT_FREQ_SLIDER,
        FLT_Q_SLIDER,

        AMP_ATTACK_SLIDER,
        AMP_DECAY_SLIDER,
        AMP_SUSTAIN_SLIDER,
        AMP_RELEASE_SLIDER,
        
        MOD_ATTACK_SLIDER,
        MOD_DECAY_SLIDER,
        MOD_SUSTAIN_SLIDER,
        MOD_RELEASE_SLIDER,

        KEY_TRACK_SLIDER,

        MOD_ENV_FLT_SLIDER,

        LFO_FREQ_SLIDER,
        LFO_PITCH_SLIDER,
        LFO_FILTER_SLIDER,

        REVERB_SLIDER
    };

    wxSlider* addCCSlider(wxWindow* parent, wxSizer* sizer, wxWindowID id, const wxString& label, uint8_t value);

    void OnExit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);

    void OnUnisonScroll(wxScrollEvent& event);

    void OnOsc1ModeScroll(wxScrollEvent& event);
    void OnOsc2ModeScroll(wxScrollEvent& event);
    void OnOscDetScroll(wxScrollEvent& event);
    void OnOsc2PitScroll(wxScrollEvent& event);
    void OnOscMixScroll(wxScrollEvent& event);

    void OnNoiseMixScroll(wxScrollEvent& event);

    void OnFltTypeScroll(wxScrollEvent& event);
    void OnFltSlopeScroll(wxScrollEvent& event);
    void OnFltFreqScroll(wxScrollEvent& event);
    void OnFltQScroll(wxScrollEvent& event);

    void OnKeyTrackScroll(wxScrollEvent& event);

    void OnAmpAttackScroll(wxScrollEvent& event);
    void OnAmpDecayScroll(wxScrollEvent& event);
    void OnAmpSustainScroll(wxScrollEvent& event);
    void OnAmpReleaseScroll(wxScrollEvent& event);

    void OnFltAttackScroll(wxScrollEvent& event);
    void OnFltDecayScroll(wxScrollEvent& event);
    void OnFltSustainScroll(wxScrollEvent& event);
    void OnFltReleaseScroll(wxScrollEvent& event);

    void OnModEnvFltGainScroll(wxScrollEvent& event);

    void OnLFOFreqScroll(wxScrollEvent& event);
    void OnLFOPitchScroll(wxScrollEvent& event);
    void OnLFOFilterScroll(wxScrollEvent& event);

    void OnReverbScroll(wxScrollEvent& event);

    wxDECLARE_EVENT_TABLE();
};

#endif